#include "stm32f10x.h"                  // Device header
#include <stdio.h>
#include <stdarg.h>

uint8_t Serial_TxPacket[4];				//巢ݰ飬ݰʽFF 01 02 03 04 FE
uint8_t Serial_RxPacket[4];				//ݰ
uint8_t Serial_RxFlag;					//ݰ־λ

/**
  *     ڳʼ
  *     
  *   ֵ
  */
void Serial_Init(void)
{
	/*ʱ*/
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1, ENABLE);	//USART1ʱ
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);	//GPIOAʱ
	
	/*GPIOʼ*/
	GPIO_InitTypeDef GPIO_InitStructure;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOA, &GPIO_InitStructure);					//PA9ųʼΪ
	
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOA, &GPIO_InitStructure);					//PA10ųʼΪ
	
	/*USARTʼ*/
	USART_InitTypeDef USART_InitStructure;					//ṹ
	USART_InitStructure.USART_BaudRate = 9600;				//
	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;	//ӲƣҪ
	USART_InitStructure.USART_Mode = USART_Mode_Tx | USART_Mode_Rx;	//ģʽģʽͽģʽѡ
	USART_InitStructure.USART_Parity = USART_Parity_No;		//żУ飬Ҫ
	USART_InitStructure.USART_StopBits = USART_StopBits_1;	//ֹͣλѡ1λ
	USART_InitStructure.USART_WordLength = USART_WordLength_8b;		//ֳѡ8λ
	USART_Init(USART1, &USART_InitStructure);				//ṹUSART_InitUSART1
	
	/*ж*/
	USART_ITConfig(USART1, USART_IT_RXNE, ENABLE);			//ڽݵж
	
	/*NVICжϷ*/
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);			//NVICΪ2
	
	/*NVIC*/
	NVIC_InitTypeDef NVIC_InitStructure;					//ṹ
	NVIC_InitStructure.NVIC_IRQChannel = USART1_IRQn;		//ѡNVICUSART1
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;			//ָNVIC·ʹ
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;		//ָNVIC·ռȼΪ1
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;		//ָNVIC·ӦȼΪ1
	NVIC_Init(&NVIC_InitStructure);							//ṹNVIC_InitNVIC
	
	/*USARTʹ*/
	USART_Cmd(USART1, ENABLE);								//ʹUSART1ڿʼ
}

/**
  *     ڷһֽ
  *     Byte Ҫ͵һֽ
  *   ֵ
  */
void Serial_SendByte(uint8_t Byte)
{
	USART_SendData(USART1, Byte);		//ֽдݼĴдUSARTԶʱ
	while (USART_GetFlagStatus(USART1, USART_FLAG_TXE) == RESET);	//ȴ
	/*´дݼĴԶɱ־λʴѭ־λ*/
}

/**
  *     ڷһ
  *     Array Ҫ׵ַ
  *     Length Ҫĳ
  *   ֵ
  */
void Serial_SendArray(uint8_t *Array, uint16_t Length)
{
	uint16_t i;
	for (i = 0; i < Length; i ++)		//
	{
		Serial_SendByte(Array[i]);		//εSerial_SendByteÿֽ
	}
}

/**
  *     ڷһַ
  *     String Ҫַ׵ַ
  *   ֵ
  */
void Serial_SendString(char *String)
{
	uint8_t i;
	for (i = 0; String[i] != '\0'; i ++)//ַ飨ַַ־λֹͣ
	{
		Serial_SendByte(String[i]);		//εSerial_SendByteÿֽ
	}
}

/**
  *     ηڲʹã
  *   ֵֵXYη
  */
uint32_t Serial_Pow(uint32_t X, uint32_t Y)
{
	uint32_t Result = 1;	//ýֵΪ1
	while (Y --)			//ִY
	{
		Result *= X;		//X۳˵
	}
	return Result;
}

/**
  *     ڷ
  *     Number Ҫ͵֣Χ0~4294967295
  *     Length ҪֵĳȣΧ0~10
  *   ֵ
  */
void Serial_SendNumber(uint32_t Number, uint8_t Length)
{
	uint8_t i;
	for (i = 0; i < Length; i ++)		//ֳȱֵÿһλ
	{
		Serial_SendByte(Number / Serial_Pow(10, Length - i - 1) % 10 + '0');	//εSerial_SendByteÿλ
	}
}

/**
  *     ʹprintfҪضĵײ㺯
  *     ԭʼʽɣ䶯
  *   ֵԭʼʽɣ䶯
  */
int fputc(int ch, FILE *f)
{
	Serial_SendByte(ch);			//printfĵײضԼķֽں
	return ch;
}

/**
  *     Լװprinf
  *     format ʽַ
  *     ... ɱĲб
  *   ֵ
  */
void Serial_Printf(char *format, ...)
{
	char String[100];				//ַ
	va_list arg;					//ɱб͵ıarg
	va_start(arg, format);			//formatʼղбarg
	vsprintf(String, format, arg);	//ʹvsprintfӡʽַͲбַ
	va_end(arg);					//arg
	Serial_SendString(String);		//ڷַ飨ַ
}

/**
  *     ڷݰ
  *     
  *   ֵ
  * ˵    ô˺Serial_TxPacketݽϰͷFFβFEΪݰͳȥ
  */
void Serial_SendPacket(void)
{
	Serial_SendByte(0xFF);
	Serial_SendArray(Serial_TxPacket, 4);
	Serial_SendByte(0xFE);
}

/**
  *     ȡڽݰ־λ
  *     
  *   ֵڽݰ־λΧ0~1յݰ󣬱־λ1ȡ־λԶ
  */
uint8_t Serial_GetRxFlag(void)
{
	if (Serial_RxFlag == 1)			//־λΪ1
	{
		Serial_RxFlag = 0;
		return 1;					//򷵻1Զ־λ
	}
	return 0;						//־λΪ0򷵻0
}

/**
  *     USART1жϺ
  *     
  *   ֵ
  * ע˺ΪжϺãжϴԶִ
  *           ΪԤָƣԴļ
  *           ȷȷκβ죬жϺܽ
  */
void USART1_IRQHandler(void)
{
	static uint8_t RxState = 0;		//ʾǰ״̬״̬ľ̬
	static uint8_t pRxPacket = 0;	//ʾǰλõľ̬
	if (USART_GetITStatus(USART1, USART_IT_RXNE) == SET)		//жǷUSART1Ľ¼ж
	{
		uint8_t RxData = USART_ReceiveData(USART1);				//ȡݼĴڽյݱ
		
		/*ʹ״̬˼·δݰĲͬ*/
		
		/*ǰ״̬Ϊ0ݰͷ*/
		if (RxState == 0)
		{
			if (RxData == 0xFF)			//ȷʵǰͷ
			{
				RxState = 1;			//һ״̬
				pRxPacket = 0;			//ݰλù
			}
		}
		/*ǰ״̬Ϊ1ݰ*/
		else if (RxState == 1)
		{
			Serial_RxPacket[pRxPacket] = RxData;	//ݴݰָλ
			pRxPacket ++;				//ݰλ
			if (pRxPacket >= 4)			//չ4
			{
				RxState = 2;			//һ״̬
			}
		}
		/*ǰ״̬Ϊ2ݰβ*/
		else if (RxState == 2)
		{
			if (RxData == 0xFE)			//ȷʵǰβ
			{
				RxState = 0;			//״̬0
				Serial_RxFlag = 1;		//ݰ־λ1ɹһݰ
			}
		}
		
		USART_ClearITPendingBit(USART1, USART_IT_RXNE);		//־λ
	}
}
